--[[
==myHonor==
By Smokey aka Mahuatahu on Earthen Ring Horde US

==To do list==
2.) (maybe?) own GUI instead of data broker --too lazy now, convenient when built into Titan Panel or FuBar
3.) BG WEEKEND
--]]

--GetBattlegroundInfo(i) space 5 THIS IS FOR HOLIDAY. USE IT LATER BRO
-- with GetNumBattlegroundTypes()

--[[ 
	Config
--]]
local mhVersion = GetAddOnMetadata("myHonor", "Version") .. " Release"
local mhAddon = "myHonor"
local mqVersion = GetAddOnMetadata("myHonor", "Version") .. " Release"
local mqAddon = "myConquest"

-- Initializing the object and frame
local honorIcon = "Interface\\PVPFrame\\PVP-Currency-"..UnitFactionGroup("player")
local conquestIcon = "Interface\\PVPFrame\\PVPCurrency-Conquest-"..UnitFactionGroup("player")
local OnEvent = function(self, event, ...) self[event](self, event, ...) end
local dataobj = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("myHonor", {
	type = "data source",
	icon = honorIcon,
})
local myHonor = {}
local frame, events = CreateFrame"Frame", {}

-- [[    Varibles, etc    ]] --
local showedUpdate, peopleUsing = false, { ["Character"] = {} }
local session, total, startTime
local mhTooltip = 1
local HonorGained, SessionHonor, StartingHonor, BGHonor, LastBG, HonorBefore = 0, 0, 0, 0, 0, 0, 0, 0, 0
local ConqTotal, StartingConquest = 0, 0
local HonorGained_InBG = 0
local BGCount, AvgHonor, EnteredBG, InBG, perHour = 0,0,0,0,0
local FinallyLoaded, AddonLded, BGstatistics, LastDate = nil, nil, true, nil
local VarisLoaded = false
local myHonor_BGCONF = 0
local myHonor_BGAUTOJOINTIMER = 30
local HonorGoal, HonorGoalFinal, ConquestGoalFinal, ConquestGoal = 0, 0, 0, 0
local ConquestGoalPercent, HonorGoalPercent = 0, 0
local Splashed = 1
local mhDisplay, mqDisplay = 1, 1
local mhHonorToday, mhHonorYesterday = 0, 0
local BGTotal = 0
local StartingHKs, SessionHKs, TotalHKs = 0,0,0
local ConquestGained, SessionCP, BGConquest, LastBG, ConquestBefore = 0, 0, 0, 0, 0, 0, 0, 0
local ConquestGained_InBG = 0
local WGCount, AvgCP, EnteredWG, InWG, WGHonor = 0,0,0,0,0
local ConqCap, ConqCapTotal = 0, 0
local mhAutoQuest, mhAutoShow = 1, 0
local SpentPoints = 0
local TotalDmg, TotalHeals, BGDmg, BGHeals = 0,0,0,0
local silentTitan = 0
local healsIcon = "|TInterface\\LFGFrame\\UI-LFG-ICON-PORTRAITROLES.blp:15:15:0:0:64:64:20:39:1:20|t"
local dmgIcon = "|TInterface\\LFGFrame\\UI-LFG-ICON-PORTRAITROLES.blp:15:15:0:0:64:64:20:39:22:41|t"
local mhDefaults = { ShowMinimapButton = true, TrackStats = true, Tooltip = 1, }


--frame:SetScript("OnEvent", OnEvent)
frame:SetScript("OnEvent", function(self, event, ...)
 events[event](self, ...); -- call one of the functions above
end);
frame:RegisterEvent"PLAYER_ENTERING_WORLD"
frame:RegisterEvent"PLAYER_LEAVING_WORLD"
frame:RegisterEvent"CURRENCY_DISPLAY_UPDATE"
frame:RegisterEvent"ADDON_LOADED"
frame:RegisterEvent"PLAYER_LOGOUT"
frame:RegisterEvent"CHAT_MSG_ADDON"
frame:RegisterEvent"RAID_ROSTER_UPDATE"

if (BGstatistics==true) then

	frame:RegisterEvent"UPDATE_BATTLEFIELD_SCORE"

end


--[[
	End Configuration
]]--

local function sendSync(prefix,msg)

local zoneType = select(2, IsInInstance())

	if zoneType == "pvp" or zoneType == "arena" then
		SendAddonMessage("myHonor", prefix .. ": " .. msg, "BATTLEGROUND")
	end
	
	if GetRealNumRaidMembers() > 0 then
		SendAddonMessage("myHonor", prefix .. ": " .. msg, "RAID")
	end
	
	if GetRealNumPartyMembers() > 0 then
		SendAddonMessage("myHonor", prefix .. ": " .. msg, "PARTY")
	end
	
	if IsInGuild() then
		SendAddonMessage("myHonor", prefix .. ": " .. msg, "GUILD")
	end

end

function events:CHAT_MSG_ADDON(prefix, msg, channel, sender)

--print("Prefix: " .. prefix,"|Msg: '" .. msg,"'|Channel: " .. channel,"|Sender: " .. sender)

if (prefix=="myHonor") then

local AlreadyIn = false

for v in pairs(peopleUsing.Character) do
	if (sender:lower()==peopleUsing.Character[v]:lower()) then
		AlreadyIn = true
	end
end

if (AlreadyIn==false) then
	table.insert(peopleUsing.Character,sender)
end

	if (string.find(msg,"V")) then
		
		--is this a beta version? probably me sending out messages in which case we will ignore :p
		if (string.find(msg,"Beta")) then return end
		
		msg = string.gsub(msg,"V: ","")
		msg = string.gsub(msg," Release","")
		msg = string.gsub(msg," ","")
		
		local CurrentVersion = string.gsub(mhVersion," Release","")
		CurrentVersion = string.gsub(CurrentVersion," Beta","")
		CurrentVersion = string.gsub(CurrentVersion," ","")
		
		if (msg > CurrentVersion and showedUpdate == false) then
			ShortPrint("myHonor is out of date. Latest Version: " .. msg .. " You have: " .. mhVersion .. ".  Please visit Curse.com to get the latest version!")
			showedUpdate = true
		end
		
	end

end

end

function events:RAID_ROSTER_UPDATE()

--someone joined the raid (BG or otherwise) send a version sync
sendSync("V",mhVersion)

end

--[[   We're logging in or entering the world, let's do work on shit    ]] --
function events:PLAYER_ENTERING_WORLD()

	if (not myHonor) then
		myHonor = {}
	end
	
	if (not startTime) then
		startTime = time()
	end
	
    HonorGained = (select(2,GetCurrencyInfo(HONOR_CURRENCY)))
	ZoneInfo = (select(2, IsInInstance()))
	InBG = 0
	
	  if (ZoneInfo == "pvp") then
	     InBG = 1 --In a battleground
 	     BGCount = BGCount + 1
		 BGTotal = tonumber(BGTotal) or 0
		 BGTotal = BGTotal + 1
	     HonorGained_InBG = HonorGained_InBG + BGHonor
	     LastBG = BGHonor
	     BGHonor = 0
         HonorBefore = (select(2,GetCurrencyInfo(HONOR_CURRENCY)))
		 BGDmg = 0
		 BGHeals = 0
		 --Should we hide the quest tracker?
		 if (mhAutoQuest==1) then --yes
		 	if (mhAutoHide==0) then
				 --HideUIPanel(WatchFrame)
				 mhAutoHide = 1
			end
		 end
	  elseif (ZoneInfo == "none") then
	  	 --Leaving Battle zone, should we bring back quest tracker?
		 if (mhAutoQuest==1) then --yes
		 	if (mhAutoHide==1) then
				 --ShowUIPanel(WatchFrame)
				 mhAutoHide = 0
			end
		 end
			 InBG = 0 --Not in a battleground
	  elseif (ZoneInfo == "arena") then
	  	 InWG = 1
		 WGCount = WGCount + 1
		 ConquestGained_InBG = ConquestGained_InBG + WGHonor
	     LastWG = WGHonor
	     WGHonor = 0
         ConquestBefore = (select(2,GetCurrencyInfo(CONQUEST_CURRENCY)))
		 --Should we hide the quest tracker?
		 if (mhAutoQuest==1) then --yes
		 	if (mhAutoHide==0) then
				 --HideUIPanel(WatchFrame)
				 mhAutoHide = 1
			end
		 end
	  end
	
	if (FinallyLoaded==nil) then
		self:CheckHonor()
	end

if (IsAddonMessagePrefixRegistered("myHonor")==false) then
	RegisterAddonMessagePrefix("myHonor")
end

sendSync("V",mhVersion)


end



---------------------
--Currency updating--
---------------------
function events:CURRENCY_DISPLAY_UPDATE()

HonorGained = (select(2,GetCurrencyInfo(HONOR_CURRENCY)))
ConqTotal = (select(2,GetCurrencyInfo(CONQUEST_CURRENCY)))
local NegativeHP = (select(2,GetCurrencyInfo(HONOR_CURRENCY))) - StartingHonor
local NegativeCP = (select(2,GetCurrencyInfo(CONQUEST_CURRENCY))) - StartingConquest

	if (FinallyLoaded==true) then
		if (NegativeHP<0) then
			SessionHonor = 0
		else
			SessionHonor = (select(2,GetCurrencyInfo(HONOR_CURRENCY))) - StartingHonor
		end
		if (NegativeCP<0) then
			SessionCP = 0
		else
			SessionCP = (select(2,GetCurrencyInfo(CONQUEST_CURRENCY))) - StartingConquest
		end
		SessionHKs = GetPVPLifetimeStats() - StartingHKs
			if (mhHonorToday==SessionHonor) then
				mhHonorToday = tonumber(mhHonorToday) or 0
				mhHonorToday = mhHonorToday + tonumber(SessionHonor)
			else
				mhHonorToday = tonumber(SessionHonor)
			end
		TotalHKs = GetPVPLifetimeStats()
		ConqCap = (select(5,GetCurrencyInfo(CONQUEST_CURRENCY)))
		ConqCapTotal = (select(4,GetCurrencyInfo(CONQUEST_CURRENCY)))


			if (not LastDate==string.sub(date(),0,8)) then --different day, clear honor today
			
			end
	

	end
	
	if (InBG==1) then
		BGHonor = (select(2,GetCurrencyInfo(HONOR_CURRENCY))) - HonorBefore
		BGConquest = (select(2,GetCurrencyInfo(CONQUEST_CURRENCY))) - ConquestBefore
	end
	
	if (BGCount>0) then
		AvgHonor = HonorGained_InBG / BGCount   
	end
	
	if (WGCount>0) then
		AvgCP = ConquestGained_InBG / WGCount   
	end

	if (Splashed==0) then

		if (HonorGoal==0) then return end
		if (HonorGoal<HonorGained) then

			CombatText_AddMessage(mH_TXT_GOALMET, CombatText_StandardScroll, 1, 0.50, 0)
			RaidNotice_AddMessage(RaidWarningFrame, mH_TXT_GOALMET, ChatTypeInfo["RAID_WARNING"])
			DEFAULT_CHAT_FRAME:AddMessage(mH_TXT_GOALMET, 1, 0.50, 0)
			PlaySound("RaidWarning")
			Splashed = 1

		end
	
		if (ConquestGoal==0) then return end
		if (ConquestGoal<ConqTotal) then

			CombatText_AddMessage(mq_TXT_GOALMET, CombatText_StandardScroll, 1, 0.50, 0)
			RaidNotice_AddMessage(RaidWarningFrame, mq_TXT_GOALMET, ChatTypeInfo["RAID_WARNING"])
			DEFAULT_CHAT_FRAME:AddMessage(mq_TXT_GOALMET, 1, 0.50, 0)
			PlaySound("RaidWarning")
			Splashed = 1

		end

	end

	if (ConquestGoal>0) then
		ConquestGoalFinal = ConquestGoal - ConqTotal
	end
	if (ConquestGoal<ConqTotal) then
		ConquestGoalFinal = GreenText("N/A")
	end

	if (HonorGoal>0) then
		HonorGoalFinal = HonorGoal - HonorGained
	else
		HonorGoalFinal = 0
	end
	if (HonorGoal<HonorGained) then
		HonorGoalFinal = GreenText("N/A")
	end

	if (mhDisplay==1) then
		dataobj.value = HonorGained
		dataobj.text = Should_I_Be_Red(HonorGained)..mH_BAR_ONE
	elseif (mhDisplay==2) then
		dataobj.value = SessionHonor
		dataobj.text = Should_I_Be_Red(SessionHonor)..mH_BAR_TWO
	elseif (mhDisplay==3) then
		dataobj.value = HonorGoalFinal
		dataobj.text = GetHighText(HonorGained).."/"..GreenText(HonorGoal)..mH_BAR_THREE
	elseif (mhDisplay==4) then
		dataobj.value = BGHonor
		dataobj.text = Should_I_Be_Red(BGHonor)..mH_BAR_FOUR
	elseif (mhDisplay==5) then
		dataobj.value = AvgHonor
		dataobj.text = Should_I_Be_Red(format("%d",AvgHonor))..mH_BAR_FIVE
	elseif (mhDisplay==6) then
		dataobj.value = TotalHKs
		dataobj.text = Should_I_Be_Red(TotalHKs)..mH_BAR_SIX
	elseif (mhDisplay==7) then
		dataobj.value = SessionHKs
		dataobj.text = Should_I_Be_Red(SessionHKs)..mH_BAR_SEVEN
	elseif (mhDisplay==8) then
		dataobj.value = ConqTotal
		dataobj.text = Should_I_Be_Red(ConqTotal)..mH_BAR_EIGHT
	elseif (mhDisplay==9) then
		dataobj.value = SessionCP
		dataobj.text = Should_I_Be_Red(SessionCP)..mH_BAR_NINE
	elseif (mhDisplay==10) then
		dataobj.value = ConquestGoalFinal
		dataobj.text = ConquestGoalFinal..mH_BAR_TEN
	elseif (mhDisplay==11) then
		dataobj.value = AvgCP
		dataobj.text = Should_I_Be_Red(AvgCP)..mH_BAR_ELEVEN
	elseif (mhDisplay==12) then
		dataobj.value = ConqCap
		dataobj.text = Should_I_Be_Red(ConqCapTotal).."/"..GreenText(ConqCap)..mH_BAR_TWELVE
	end

end

function events:ADDON_LOADED(arg1)

if (arg1=="myHonor") then --good to go, set variables
if (VarisLoaded==true) then
return;
else

	if (not mhOptions) then mhOptions = mhDefaults end
	if (myHonor_BGStats) then BGstatistics = myHonor_BGStats end
	if (myHonor_DATE) then LastDate = myHonor_DATE end
	if (myHonor_Goal) then HonorGoal = myHonor_Goal end
	if (myHonor_Display) then mhDisplay = myHonor_Display end
	if (myHonor_HonorToday) then mhHonorToday = myHonor_HonorToday end
	if (myHonor_HonorYesterday) then mhHonorYesterday = myHonor_HonorYesterday end
	if (mh_BGCount) then BGTotal = tonumber(mh_BGCount) end
	if (mhTTDisplay) then mhTooltip = mhTTDisplay end
	if (myConquest_Goal) then ConquestGoal = myConquest_Goal end
	if (myConquest_Display) then mqDisplay = myConquest_Display end
	if (mq_BGCount) then WGTotal = tonumber(mq_BGCount) end
	if (myHonor_AHQ) then mhAutoQuest = myHonor_AHQ end
	if not mhOptions.ShowMinimapButton then frame:HideMinimapButton() end
	VarisLoaded = true
	if (LastDate) then
	if (string.sub(LastDate,4,5)==string.sub(date(),4,5)-1) then --yesterday
		BGTotal = 0
		mh_BGCount = 0
		mhHonorYesterday = mhHonorToday
		mhHonorToday = 0
	else
		BGTotal = 0
		mh_BGCount = 0
		mhHonorToday = 0
		mhHonorYesterday = 0
	end
	end

end
end

end

function events:PLAYER_LEAVING_WORLD()

self:SaveStuff()

end

function events:PLAYER_LOGOUT()

self:SaveStuff()

end

function frame:SaveStuff()

local TheDate = string.sub(date(),0,8)

myHonor_BGStats = BGstatistics
myHonor_DATE = TheDate
myHonor_Goal = HonorGoal
myHonor_Display = mhDisplay
myHonor_HonorToday = mhHonorToday
myHonor_HonorYesterday = mhHonorYesterday
mh_BGCount = BGTotal
mhTTDisplay = mhTooltip
myHonor_AHQ = mhAutoQuest

myConquest_DATE = TheDate
myConquest_Goal = ConquestGoal
myConquest_Display = mqDisplay
mq_BGCount = WGTotal

end

function events:UPDATE_BATTLEFIELD_SCORE()

local PlayerName, myFaction, myDamage, myHealing, playerWon = 0,0,0,0,0
--Work in progress, i'm convinced it is no longer possible to do this with an add-on.
for i=1, GetNumBattlefieldScores() do

		local name, _, _, _, _, _, race, class, classToken, damageDone, healingDone = GetBattlefieldScore(i)
				
		if (name==UnitName("player")) then
			PlayerName = name
			myFaction = faction
			myDamage = damageDone
			myHealing = healingDone
		end
		
end

if (InBG==1) then

BGDmg = myDamage
BGHeals = myHealing

	if( GetBattlefieldWinner() ) then
		--playerWon = 1
		TotalDmg = tonumber(TotalDmg) or 0
		TotalDmg = tonumber(TotalDmg)+tonumber(BGDmg)
		TotalHeals = tonumber(TotalHeals) or 0
		TotalHeals = tonumber(TotalHeals)+tonumber(BGHeals)
		BGDmg = 0
		BGHeals = 0
		InBG = 0
	end
end


end

-- [[   The tooltip  ]] --
function dataobj.OnTooltipShow(tooltip)

	 local hc, InBGtext, pname, rname, fname
     pname = GetHighText(UnitName("player"))
     rname = GreenText(GetCVar("realmname"))
     fname = UnitFactionGroup("player")
     hc = GetPVPLifetimeStats()
	 local sessionTime = time() - startTime
	 local AJBGtext
	 local HonorGoalFinal, HonorGoalTime, ConquestGoalFinal, ConquestGoalTime = 0, 0, 0, 0
	 local HonorGoalPercent = 0
     if (InBG==1) then
     	InBGtext = RedText(GetZoneText())
     	else 
     	InBGtext = GreenText("No")
     end
	 if (BGstatistics==true) then
	 	AJBGtext = "Enabled"
	 	else
	 	AJBGtext = "Disabled"
	 end
--which tooltip to select, Honor or Conquest
 if (mhTooltip==1) then
	if (SessionHonor>0) then
		if (startTime) then perHour = SessionHonor / sessionTime * 3600 end
	else
		perHour = 0
	end
	--xpPerHour = 
	if (fname=="Alliance") then
        fname = BlueText(UnitFactionGroup("player"))
     else
        fname = RedText(UnitFactionGroup("player"))
     end
	 if (HonorGoal>0) then
	 	HonorGoalFinal = HonorGoal - HonorGained
		HonorGoalPercent = (HonorGained/HonorGoal) * 100
		HonorGoalPercent = ("%.1f"):format(HonorGoalPercent)
		if (BGCount>0) then
			if (AvgHonor>0) then
				HonorGoalTime = HonorGoalFinal/AvgHonor
				HonorGoalTime = format("%d",HonorGoalTime)
			else
				HonorGoalTime = "N/A"
			end
		else
			HonorGoalTime = "N/A"
		end
	 else
	 	HonorGoalFinal = "N/A"
	 end
	 
	 if (HonorGoal==0) then
	 	HonorGoalTime = GetHighText("N/A")
	 	HonorGoalPercent = 0
	 elseif (HonorGoal<HonorGained) then
		HonorGoalFinal = GreenText("Goal Accomplished!")
		HonorGoalPercent = 0
	 end
	-- Arena points
	--local arena = GetArenaCurrency()
	--if(arena > 0) then
	--	tooltip:AddDoubleLine("Arena points:", arena.." "..texturizeIcon(arenaIcon), 1,1,1, 0,1,0)
	--end

	tooltip:AddLine(pname.." - "..rname.." ("..fname..") "..texIcon(honorIcon))
	tooltip:AddLine(GetHighText(mhAddon.." v"..mhVersion))
	tooltip:AddLine(" ")
	tooltip:AddDoubleLine(mH_TT_STATUS,InBGtext)
	tooltip:AddDoubleLine(mH_TT_TOTALPTS,GetHighText(StartingHonor)..texIcon(honorIcon))
	tooltip:AddDoubleLine(mH_TT_TOTALHKS,GetHighText(hc))
	tooltip:AddDoubleLine(mH_TT_TODAYPTS,GetHighText(mhHonorToday)..texIcon(honorIcon))
	tooltip:AddDoubleLine(mH_TT_YESPTS,GetHighText(mhHonorYesterday)..texIcon(honorIcon))
	tooltip:AddLine("----------------------------------")
	tooltip:AddLine(GetHighText(mH_TT_SESSIONSTATS))
	tooltip:AddDoubleLine(mH_TT_SESSIONPTS,Should_I_Be_Red(SessionHonor))
	tooltip:AddDoubleLine(mH_TT_SESSIONHKS,Should_I_Be_Red(SessionHKs))
	tooltip:AddDoubleLine(mH_TT_TTLDMG,RedText(siUnits(TotalDmg))..dmgIcon)
	tooltip:AddDoubleLine(mH_TT_TTLHEAL,GreenText(siUnits(TotalHeals))..healsIcon)
	tooltip:AddLine("----------------------------------")
	tooltip:AddDoubleLine(GetHighText(mH_TT_BGSTATS))
	tooltip:AddDoubleLine(mH_TT_LASTBG,Should_I_Be_Red(LastBG))
	tooltip:AddDoubleLine(mH_TT_BGHONOR,Should_I_Be_Red(BGHonor))
	tooltip:AddDoubleLine(mH_TT_AVGHONOR,Should_I_Be_Red(format("%d",AvgHonor)))
	tooltip:AddDoubleLine(mH_TT_BGCOUNT,Should_I_Be_Red(BGCount))
	tooltip:AddDoubleLine(mH_TT_BGTTL,Should_I_Be_Red(BGTotal))
	tooltip:AddDoubleLine(mH_TT_PERHR,Should_I_Be_Red(format("%d",perHour)))
	tooltip:AddDoubleLine(mH_TT_BGDMG,RedText(BGDmg)..dmgIcon)
	tooltip:AddDoubleLine(mH_TT_BGHEAL,GreenText(BGHeals)..healsIcon)
	tooltip:AddLine("----------------------------------")
	tooltip:AddDoubleLine(mH_TT_GOALTEXT,GetHighText(HonorGained).."/"..GreenText(HonorGoal).." "..PurpleText("\("..HonorGoalPercent.."\%\)"))
	tooltip:AddDoubleLine(mH_TT_GOALTEXT2,GetHighText(HonorGoalFinal))
	tooltip:AddDoubleLine(mH_TT_GOALTIME,GreenText("~"..HonorGoalTime))
	tooltip:AddLine(" ")
	tooltip:AddLine(mH_TT_CLICKTOGGLE)
	tooltip:AddLine(GreenText(mH_TT_RCLICK),nil,nil,nil,1)
	tooltip.updateFunction = dataobj.OnTooltipShow
 else
 --[[
	 Conquest
 --]]
	local teamTwos, teamThrees, teamFives = {}, {}, {}
	local ConquestPossible
	local CurrentSeason = GetCurrentArenaSeason()
	local Team2Final, Team3Final, Team5Final
	local CPPercent, CPcapPercent = 0, 0
	
	teamTwos = { ["arenaName"] = "None", ["arenaRating"] = 0, ["PR"] = 0 }
	teamThrees = { ["arenaName"] = "None", ["arenaRating"] = 0, ["PR"] = 0 }
	teamFives = { ["arenaName"] = "None", ["arenaRating"] = 0, ["PR"] = 0 }
	
 	for i=1, MAX_ARENA_TEAMS do
		local teamName, teamSize, teamRating = GetArenaTeam(i)
		local personalRating = (select(11,GetArenaTeam(i)))
		
		if (teamName) then
			if (i==1) then
			--2v2
			teamTwos["arenaName"] = teamName
			teamTwos["arenaRating"] = teamRating
			teamTwos.PR = personalRating
			end
			if (i==2) then
			--3v3
			teamThrees["arenaName"] = teamName
			teamThrees["arenaRating"] = teamRating
			teamThrees.PR = personalRating
			end
			if (i==3) then
			--5v5
			teamFives["arenaName"] = teamName
			teamFives["arenaRating"] = teamRating
			teamFives.PR = personalRating
			end
			
		end
	end
	
 if (SessionCP>0) then
		if (startTime) then perHour = SessionCP / sessionTime * 3600 end
	else
		perHour = 0
	end
	--xpPerHour = 
	if (fname=="Alliance") then
        fname = BlueText(UnitFactionGroup("player"))
     else
        fname = RedText(UnitFactionGroup("player"))
     end
	 if (ConquestGoal>0) then
	 	ConquestGoalFinal = ConquestGoal - ConqTotal
		ConquestGoalPercent = (ConqTotal/ConquestGoal) * 100
		ConquestGoalPercent = ("%.1f"):format(ConquestGoalPercent)
		CPcapPercent = (ConqCapTotal/ConqCap) * 100
		CPcapPercent = ("%.1f"):format(CPcapPercent)
		if (WGCount>0) then
			if (AvgCP>0) then
				ConquestGoalTime = ConquestGoalFinal/AvgCP
				ConquestGoalTime = format("%d",ConquestGoalTime)
			else
				ConquestGoalTime = "N/A"
			end
		else
			ConquestGoalTime = "N/A"
		end
	 else
	 	ConquestGoalFinal = "N/A"
	 end
	 if (ConquestGoal>0) then
		if (ConqCap-ConqCapTotal>ConquestGoalFinal) then
			ConquestPossible = GreenText("Yes")
		else
			ConquestPossible = RedText("No")
		end
	 else
	 	ConquestPossible = GreenText("N\/A")
	 end
	 if (ConquestGoal==0) then
	 ConquestGoalTime = GetHighText("N/A")
	 elseif (ConquestGoal<ConqTotal) then
		ConquestGoalFinal = GreenText("Goal Accomplished!")
	 end
	
	tooltip:AddLine(pname.." - "..rname.." ("..fname..") "..texIcon(conquestIcon))
	tooltip:AddLine(GetHighText(mqAddon.." v"..mqVersion))
	tooltip:AddLine(GetHighText(mC_TT_SEASONTXT..CurrentSeason))
	tooltip:AddLine(" ")
	tooltip:AddDoubleLine(mC_TT_STATUS,InBGtext)
	tooltip:AddLine("----------------------------------")
	tooltip:AddDoubleLine(GetHighText(mC_TT_WGSTATS))
	tooltip:AddDoubleLine(mC_TT_LASTWG,Should_I_Be_Red(LastBG))
	tooltip:AddDoubleLine(mC_TT_SESSIONCP,Should_I_Be_Red(SessionCP))
	tooltip:AddDoubleLine(mC_TT_AVGPTS,Should_I_Be_Red(format("%d",AvgCP)))
	tooltip:AddDoubleLine(mC_TT_BGCOUNT,Should_I_Be_Red(WGCount))
	tooltip:AddDoubleLine(mC_TT_CAP,Should_I_Be_Red(ConqCapTotal).."/"..GreenText(ConqCap)..PurpleText(" \("..CPcapPercent.."\%\)"))
	tooltip:AddDoubleLine(mC_TT_PERHR,Should_I_Be_Red(format("%d",perHour)))
	tooltip:AddLine("----------------------------------")
	tooltip:AddDoubleLine(mC_TT_GOALTEXT,GreenText(ConqTotal.."/"..ConquestGoal)..PurpleText(" \("..ConquestGoalPercent.."\%\)"))
	tooltip:AddDoubleLine(mC_TT_GOALTEXT2,GetHighText(ConquestGoalFinal))
	tooltip:AddDoubleLine(mC_TT_GOALTIME,GreenText("~"..ConquestGoalTime))
	tooltip:AddDoubleLine(mC_TT_POSSIBLE,ConquestPossible)
	tooltip:AddLine("----------------------------------")
	tooltip:AddLine(GetHighText("2v2 Team Statistics"))
	tooltip:AddLine("Team Name: "..GreenText(teamTwos["arenaName"]))
	tooltip:AddLine("Team Rating: "..GetHighText(teamTwos["arenaRating"]))
	tooltip:AddLine("Conquest Point Cap: "..OrangeText(GetConqCap(teamTwos.PR)))
	tooltip:AddLine(GetHighText("3v3 Team Statistics"))
	tooltip:AddLine("Team Name: "..GreenText(teamThrees["arenaName"]))
	tooltip:AddLine("Team Rating: "..GetHighText(teamThrees["arenaRating"]))
	tooltip:AddLine("Conquest Point Cap: "..OrangeText(GetConqCap(teamThrees.PR)))
	tooltip:AddLine(GetHighText("5v5 Team Statistics"))
	tooltip:AddLine("Team Name: "..GreenText(teamFives["arenaName"]))
	tooltip:AddLine("Team Rating: "..GetHighText(teamFives["arenaRating"]))
	tooltip:AddLine("Conquest Point Cap: "..OrangeText(GetConqCap(teamFives.PR)))
	tooltip:AddLine(" ")
	tooltip:AddLine(mH_TT_CLICKTOGGLE)
	tooltip:AddLine(GreenText(mC_TT_RCLICK),nil,nil,nil,1)
	tooltip.updateFunction = dataobj.OnTooltipShow
 end
end

SLASH_GOAL1 = "/goal"
function SlashCmdList.GOAL(msg)

local cmd = msg:lower()

if (cmd=="") then
	
	ShortPrint(mH_TXT_GOALSYN)

elseif (tonumber(msg)>40000) then

	ShortPrint(mH_TXT_GOALERR)
	
else

	if (mhTooltip==1) then
	--honor
		HonorGoal = tonumber(msg)
		ShortPrint(mH_TXT_GOALSET..HonorGoal)
		Splashed = 0
		events:CURRENCY_DISPLAY_UPDATE()
	
	else
	
	--conquest
		ConquestGoal = tonumber(msg)
		ShortPrint(mq_TXT_GOALSET..ConquestGoal)
		Splashed = 0
		events:CURRENCY_DISPLAY_UPDATE()
	
	end
	
end

end

SLASH_AJBG1 = "/mh"
function SlashCmdList.AJBG(msg)
local cmd = msg:lower()

if (cmd=="ahquest") then
	if (mhAutoQuest==0) then
		mhAutoQuest = 1
		ShortPrint("Auto Quest Tracker Hider ON")
	else
		mhAutoQuest = 0
		ShortPrint("Auto Quest Tracker Hider OFF")
	end
elseif (cmd=="tt") then
	if (mhTooltip==1) then
		if (UnitLevel("player")==85) then
			mhTooltip = 2
		end
	elseif (mhTooltip==2) then
		mhTooltip = 1
	end
elseif (cmd=="mm") then
	frame:ToggleMinimapButton()
elseif (cmd=="goal") then
	ShortPrint(mH_TXT_GOALSYN)
elseif (cmd=="help" or cmd=="") then
	ShortPrint(mH_HELP_ONE)
	ShortPrint(mH_HELP_TWO)
	ShortPrint(mH_HELP_THREE)
	ShortPrint(mH_HELP_FIVE)
	ShortPrint(mH_HELP_SIX..mhVersion)
elseif (cmd=="secret") then
	print("People using add-on:",table.getn(peopleUsing.Character))
elseif (cmd=="bgstat") then
	frame:CallBGStat()
elseif (cmd=="reset") then
	SessionHonor = 0
	BGHonor = 0
	BGCount = 0
	AvgHonor = 0
	LastBG = 0
	TotalDmg = 0
	TotalHeals = 0
else
	ShortPrint(mH_HELP_ONE)
	ShortPrint(mH_HELP_TWO)
	ShortPrint(mH_HELP_THREE)
	ShortPrint(mH_HELP_FOUR)
	ShortPrint(mH_HELP_FIVE)
	ShortPrint(mH_HELP_SIX..mhVersion)
end

end

function ShortPrint(text)

	DEFAULT_CHAT_FRAME:AddMessage("myHonor: " .. text, 0.41, 0.80, 0.94)

end

function frame:CallBGStat()

if (BGstatistics==true) then
	BGstatistics=false
	ShortPrint("No longer tracking BG damage.")
	frame:UnregisterEvent"UPDATE_BATTLEFIELD_SCORE"
	else
	BGstatistics=true
	ShortPrint("BG Damage tracking enabled.")
	frame:RegisterEvent"UPDATE_BATTLEFIELD_SCORE"
end

end

function dataobj.OnClick(self, button)
	if(button == "RightButton") then
		if (mhTooltip==1) then
			if (UnitLevel("player")==85) then
				mhTooltip = 2
			end
		elseif (mhTooltip==2) then
			mhTooltip = 1
		end
	else
		if (mhTooltip) then
			if (mhDisplay==12) then
				mhDisplay = 1
			else
				mhDisplay = mhDisplay + 1
			end
		end

	end
	
	events:CURRENCY_DISPLAY_UPDATE()
	
end



function frame:CheckHonor()

if (FinallyLoaded==nil) then
	StartingHonor = (select(2,GetCurrencyInfo(HONOR_CURRENCY)))
	StartingHKs = GetPVPLifetimeStats()
	StartingConquest = (select(2,GetCurrencyInfo(CONQUEST_CURRENCY)))
	FinallyLoaded = true
end

end

----------------------
--  Minimap Button  --
----------------------
do
	local dragMode = nil
	
	local function moveButton(self)
		if dragMode == "free" then
			local centerX, centerY = Minimap:GetCenter()
			local x, y = GetCursorPosition()
			x, y = x / self:GetEffectiveScale() - centerX, y / self:GetEffectiveScale() - centerY
			self:ClearAllPoints()
			self:SetPoint("CENTER", x, y)
		else
			local centerX, centerY = Minimap:GetCenter()
			local x, y = GetCursorPosition()
			x, y = x / self:GetEffectiveScale() - centerX, y / self:GetEffectiveScale() - centerY
			centerX, centerY = math.abs(x), math.abs(y)
			centerX, centerY = (centerX / math.sqrt(centerX^2 + centerY^2)) * 80, (centerY / sqrt(centerX^2 + centerY^2)) * 80
			centerX = x < 0 and -centerX or centerX
			centerY = y < 0 and -centerY or centerY
			self:ClearAllPoints()
			self:SetPoint("CENTER", centerX, centerY)
		end
	end

	local button = CreateFrame("Button", "myHonorButton", Minimap)
	button:SetHeight(32)
	button:SetWidth(32)
	button:SetFrameStrata("MEDIUM")
	button:SetPoint("CENTER", -65.35, -38.8)
	button:SetMovable(true)
	button:SetUserPlaced(true)
	button:SetNormalTexture(honorIcon)
	button:SetPushedTexture(honorIcon)
	button:SetHighlightTexture(honorIcon)

	button:SetScript("OnMouseDown", function(self, button)
		if IsShiftKeyDown() and IsAltKeyDown() then
			dragMode = "free"
			self:SetScript("OnUpdate", moveButton)
		elseif IsShiftKeyDown() then
			dragMode = nil
			self:SetScript("OnUpdate", moveButton)
		elseif (button == "RightButton" or button == "LeftButton") then
			if (mhTooltip==1) then
				if (UnitLevel("player")==85) then
					mhTooltip = 2
					GameTooltip:Hide()
				end
			elseif (mhTooltip==2) then
				mhTooltip = 1
				GameTooltip:Hide()
			end
		end
	end)
	button:SetScript("OnMouseUp", function(self)
		self:SetScript("OnUpdate", nil)
	end)
	button:SetScript("OnClick", function(self, button)
		
		
	end)
	button:SetScript("OnEnter", function(self)
										 
		--GameTooltip_SetDefaultAnchor(GameTooltip, self)
		GameTooltip:SetOwner(self, "ANCHOR_BOTTOMLEFT")
		local hc, InBGtext, pname, rname, fname
     	pname = GetHighText(UnitName("player"))
     	rname = GreenText(GetCVar("realmname"))
     	fname = UnitFactionGroup("player")
     	hc = GetPVPLifetimeStats()
	if (mhTooltip==1) then
		
	 	local sessionTime = time() - startTime
	 	local AJBGtext
	 	local HonorGoalFinal, HonorGoalTime, ConquestGoalFinal, ConquestGoalTime = 0, 0, 0, 0
	 	local HonorGoalPercent = 0
     	if (InBG==1) then
     		InBGtext = RedText(GetZoneText())
     	else 
     		InBGtext = GreenText("No")
     	end

		if (SessionHonor>0) then
			if (startTime) then perHour = SessionHonor / sessionTime * 3600 end
		else
		perHour = 0
		end
		if (fname=="Alliance") then
        	fname = BlueText(UnitFactionGroup("player"))
     	else
        	fname = RedText(UnitFactionGroup("player"))
     	end
		 if (HonorGoal>0) then
	 		HonorGoalFinal = HonorGoal - HonorGained
			HonorGoalPercent = (HonorGained/HonorGoal) * 100
			HonorGoalPercent = ("%.1f"):format(HonorGoalPercent)
			if (BGCount>0) then
				if (AvgHonor>0) then
					HonorGoalTime = HonorGoalFinal/AvgHonor
					HonorGoalTime = format("%d",HonorGoalTime)
				else
					HonorGoalTime = "N/A"
				end
			else
				HonorGoalTime = "N/A"
			end
	 	else
	 		HonorGoalFinal = "N/A"
		 end
	 
		 if (HonorGoal==0) then
		 	HonorGoalTime = GetHighText("N/A")
		 	HonorGoalPercent = 0
		 elseif (HonorGoal<HonorGained) then
			HonorGoalFinal = GreenText("Goal Accomplished!")
			HonorGoalPercent = 0
		 end

		GameTooltip:AddLine(pname.." - "..rname.." ("..fname..") "..texIcon(honorIcon))
		GameTooltip:AddLine(GetHighText(mhAddon.." v"..mhVersion))
		GameTooltip:AddLine(" ")
		GameTooltip:AddDoubleLine(mH_TT_STATUS,InBGtext)
		GameTooltip:AddDoubleLine(mH_TT_TOTALPTS,GetHighText(StartingHonor)..texIcon(honorIcon))
		GameTooltip:AddDoubleLine(mH_TT_TOTALHKS,GetHighText(hc))
		GameTooltip:AddDoubleLine(mH_TT_TODAYPTS,GetHighText(mhHonorToday)..texIcon(honorIcon))
		GameTooltip:AddDoubleLine(mH_TT_YESPTS,GetHighText(mhHonorYesterday)..texIcon(honorIcon))
		GameTooltip:AddLine("----------------------------------")
		GameTooltip:AddLine(GetHighText(mH_TT_SESSIONSTATS))
		GameTooltip:AddDoubleLine(mH_TT_SESSIONPTS,Should_I_Be_Red(SessionHonor))
		GameTooltip:AddDoubleLine(mH_TT_SESSIONHKS,Should_I_Be_Red(SessionHKs))
		GameTooltip:AddDoubleLine(mH_TT_TTLDMG,RedText(siUnits(TotalDmg))..dmgIcon)
		GameTooltip:AddDoubleLine(mH_TT_TTLHEAL,GreenText(siUnits(TotalHeals))..healsIcon)
		GameTooltip:AddLine("----------------------------------")
		GameTooltip:AddDoubleLine(GetHighText(mH_TT_BGSTATS))
		GameTooltip:AddDoubleLine(mH_TT_LASTBG,Should_I_Be_Red(LastBG))
		GameTooltip:AddDoubleLine(mH_TT_BGHONOR,Should_I_Be_Red(BGHonor))
		GameTooltip:AddDoubleLine(mH_TT_AVGHONOR,Should_I_Be_Red(format("%d",AvgHonor)))
		GameTooltip:AddDoubleLine(mH_TT_BGCOUNT,Should_I_Be_Red(BGCount))
		GameTooltip:AddDoubleLine(mH_TT_BGTTL,Should_I_Be_Red(BGTotal))
		GameTooltip:AddDoubleLine(mH_TT_PERHR,Should_I_Be_Red(format("%d",perHour)))
		GameTooltip:AddDoubleLine(mH_TT_BGDMG,RedText(BGDmg)..dmgIcon)
		GameTooltip:AddDoubleLine(mH_TT_BGHEAL,GreenText(BGHeals)..healsIcon)
		GameTooltip:AddLine("----------------------------------")
		GameTooltip:AddDoubleLine(mH_TT_GOALTEXT,GetHighText(HonorGained).."/"..GreenText(HonorGoal).." "..PurpleText("\("..HonorGoalPercent.."\%\)"))
		GameTooltip:AddDoubleLine(mH_TT_GOALTEXT2,GetHighText(HonorGoalFinal))
		GameTooltip:AddDoubleLine(mH_TT_GOALTIME,GreenText("~"..HonorGoalTime))
		GameTooltip:AddLine(" ")
		GameTooltip:AddLine(mH_TT_CLICKTOGGLE)
		GameTooltip:AddLine(GreenText(mH_TT_RCLICK),nil,nil,nil,1)
		
	else
		local teamTwos, teamThrees, teamFives = {}, {}, {}
	local ConquestPossible
	local CurrentSeason = GetCurrentArenaSeason()
	local Team2Final, Team3Final, Team5Final
	local CPPercent, CPcapPercent = 0, 0
	
	teamTwos = { ["arenaName"] = "None", ["arenaRating"] = 0, ["PR"] = 0 }
	teamThrees = { ["arenaName"] = "None", ["arenaRating"] = 0, ["PR"] = 0 }
	teamFives = { ["arenaName"] = "None", ["arenaRating"] = 0, ["PR"] = 0 }
	
 	for i=1, MAX_ARENA_TEAMS do
		local teamName, teamSize, teamRating = GetArenaTeam(i)
		local personalRating = (select(11,GetArenaTeam(i)))
		
		if (teamName) then
			if (i==1) then
			--2v2
			teamTwos["arenaName"] = teamName
			teamTwos["arenaRating"] = teamRating
			teamTwos.PR = personalRating
			end
			if (i==2) then
			--3v3
			teamThrees["arenaName"] = teamName
			teamThrees["arenaRating"] = teamRating
			teamThrees.PR = personalRating
			end
			if (i==3) then
			--5v5
			teamFives["arenaName"] = teamName
			teamFives["arenaRating"] = teamRating
			teamFives.PR = personalRating
			end
			
		end
	end
	
 if (SessionCP>0) then
		if (startTime) then perHour = SessionCP / sessionTime * 3600 end
	else
		perHour = 0
	end
	--xpPerHour = 
	if (fname=="Alliance") then
        fname = BlueText(UnitFactionGroup("player"))
     else
        fname = RedText(UnitFactionGroup("player"))
     end
	 if (ConquestGoal>0) then
	 	ConquestGoalFinal = ConquestGoal - ConqTotal
		ConquestGoalPercent = (ConqTotal/ConquestGoal) * 100
		ConquestGoalPercent = ("%.1f"):format(ConquestGoalPercent)
		CPcapPercent = (ConqCapTotal/ConqCap) * 100
		CPcapPercent = ("%.1f"):format(CPcapPercent)
		if (WGCount>0) then
			if (AvgCP>0) then
				ConquestGoalTime = ConquestGoalFinal/AvgCP
				ConquestGoalTime = format("%d",ConquestGoalTime)
			else
				ConquestGoalTime = "N/A"
			end
		else
			ConquestGoalTime = "N/A"
		end
	 else
	 	ConquestGoalFinal = "N/A"
	 end
	 if (ConquestGoal>0) then
		if (ConqCap-ConqCapTotal>ConquestGoalFinal) then
			ConquestPossible = GreenText("Yes")
		else
			ConquestPossible = RedText("No")
		end
	 else
	 	ConquestPossible = GreenText("N\/A")
	 end
	 if (ConquestGoal==0) then
	 ConquestGoalTime = GetHighText("N/A")
	 elseif (ConquestGoal<ConqTotal) then
		ConquestGoalFinal = GreenText("Goal Accomplished!")
	 end
	
	GameTooltip:AddLine(pname.." - "..rname.." ("..fname..") "..texIcon(conquestIcon))
	GameTooltip:AddLine(GetHighText(mqAddon.." v"..mqVersion))
	GameTooltip:AddLine(GetHighText(mC_TT_SEASONTXT..CurrentSeason))
	GameTooltip:AddLine(" ")
	GameTooltip:AddDoubleLine(mC_TT_STATUS,InBGtext)
	GameTooltip:AddLine("----------------------------------")
	GameTooltip:AddDoubleLine(GetHighText(mC_TT_WGSTATS))
	GameTooltip:AddDoubleLine(mC_TT_LASTWG,Should_I_Be_Red(LastBG))
	GameTooltip:AddDoubleLine(mC_TT_SESSIONCP,Should_I_Be_Red(SessionCP))
	GameTooltip:AddDoubleLine(mC_TT_AVGPTS,Should_I_Be_Red(format("%d",AvgCP)))
	GameTooltip:AddDoubleLine(mC_TT_BGCOUNT,Should_I_Be_Red(WGCount))
	GameTooltip:AddDoubleLine(mC_TT_CAP,Should_I_Be_Red(ConqCapTotal).."/"..GreenText(ConqCap)..PurpleText(" \("..CPcapPercent.."\%\)"))
	GameTooltip:AddDoubleLine(mC_TT_PERHR,Should_I_Be_Red(format("%d",perHour)))
	GameTooltip:AddLine("----------------------------------")
	GameTooltip:AddDoubleLine(mC_TT_GOALTEXT,GreenText(ConqTotal.."/"..ConquestGoal)..PurpleText(" \("..ConquestGoalPercent.."\%\)"))
	GameTooltip:AddDoubleLine(mC_TT_GOALTEXT2,GetHighText(ConquestGoalFinal))
	GameTooltip:AddDoubleLine(mC_TT_GOALTIME,GreenText("~"..ConquestGoalTime))
	GameTooltip:AddDoubleLine(mC_TT_POSSIBLE,ConquestPossible)
	GameTooltip:AddLine("----------------------------------")
	GameTooltip:AddLine(GetHighText("2v2 Team Statistics"))
	GameTooltip:AddLine("Team Name: "..GreenText(teamTwos["arenaName"]))
	GameTooltip:AddLine("Team Rating: "..GetHighText(teamTwos["arenaRating"]))
	GameTooltip:AddLine("Conquest Point Cap: "..OrangeText(GetConqCap(teamTwos.PR)))
	GameTooltip:AddLine(GetHighText("3v3 Team Statistics"))
	GameTooltip:AddLine("Team Name: "..GreenText(teamThrees["arenaName"]))
	GameTooltip:AddLine("Team Rating: "..GetHighText(teamThrees["arenaRating"]))
	GameTooltip:AddLine("Conquest Point Cap: "..OrangeText(GetConqCap(teamThrees.PR)))
	GameTooltip:AddLine(GetHighText("5v5 Team Statistics"))
	GameTooltip:AddLine("Team Name: "..GreenText(teamFives["arenaName"]))
	GameTooltip:AddLine("Team Rating: "..GetHighText(teamFives["arenaRating"]))
	GameTooltip:AddLine("Conquest Point Cap: "..OrangeText(GetConqCap(teamFives.PR)))
	GameTooltip:AddLine(" ")
	GameTooltip:AddLine(mH_TT_CLICKTOGGLE)
	GameTooltip:AddLine(GreenText(mC_TT_RCLICK),nil,nil,nil,1)
	end
		GameTooltip:Show()
		
	end)
	button:SetScript("OnLeave", function(self)
		GameTooltip:Hide()
	end)

	function frame:ToggleMinimapButton()
		mhOptions.ShowMinimapButton = not mhOptions.ShowMinimapButton
		if mhOptions.ShowMinimapButton then
			button:Show()
			ShortPrint("Minimap button is now showing.")
		else
			button:Hide()
			ShortPrint("Minimap button is now hidden.")
		end
	end

	function frame:HideMinimapButton()
		return button:Hide()
	end
end

function myHonorTT(GameTooltip,which)

	--work in progress

end

--word, opyright Smokey, 2011 All Rights Reserved, released under GNU License #3.
--if you're going to edit, at least give me credit or tell me about it and we can work together
--2010